unit Hauptfenster;

{$DEFINE kMitRegistrierung}
{Wenn "MitRegistrierung" definiert ist, wird die
 Registrierungsfunktionalitt mit eingebaut
 => etwas langsamerer Programmstart, da eine Datei zustzlich
 geladen wird}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Buttons, Menus, Grids, Gauges, MPlayer;

TYPE TTermin = RECORD
                 Datum     : TDateTime;  {Delphi Datumformat}
                 Tag,
                 Monat,
                 Jahr      : ShortString;
                 Bemerkung : ShortString;
               END;

type
  TFormHauptfenster = class(TForm)
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Optionen1: TMenuItem;
    Infoueber1: TMenuItem;
    Termindateibearbeiten1: TMenuItem;
    N2: TMenuItem;
    Beenden1: TMenuItem;
    Panel2: TPanel;
    BitBtnSchliessen: TBitBtn;
    ButtonStopCountdown: TButton;
    Label1: TLabel;
    Timer1: TTimer;
    Label2: TLabel;
    Gauge1: TGauge;
    Label3: TLabel;
    PopupMenu1: TPopupMenu;
    TerminDateibearbeiten2: TMenuItem;
    Hilfe2: TMenuItem;   { Menpunkt Hilfe(enthlt Kurzhilfe und Info)}
    Kurzhilfe1: TMenuItem;
    Label4: TLabel;
    Termindateineuladen1: TMenuItem;
    Termindateidrucken1: TMenuItem;
    angezeigteTerminedrucken1: TMenuItem;
    procedure Beenden1Click(Sender: TObject);
    procedure Infoueber1Click(Sender: TObject);
    procedure Optionen1Click(Sender: TObject);
    procedure ButtonStopCountdownClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Termindateibearbeiten1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Kurzhilfe1Click(Sender: TObject);
    procedure Termindateineuladen1Click(Sender: TObject);
    procedure Termindateidrucken1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    CountDownZaehler : CARDINAL;
    PROCEDURE ArraySortieren(Max : CARDINAL); {Max : maximal belegter Arrayplatz}
  public
    { Public-Deklarationen }
    Termine : ARRAY [1..1000] OF TTermin;
    PROCEDURE Init;  {Siehe Komentar in der Implementation!}
    PROCEDURE CountDown_starten;
    PROCEDURE Termine_drucken;
  end;

var
  FormHauptfenster: TFormHauptfenster;

{=== IMPLEMENTATION ===========================================================}
IMPLEMENTATION

uses Info, Optionen,ZusatzProcs, Kurzhilfe, Printers
        {$IFDEF MitRegistrierung} , Registrieren {$ENDIF};

{$R *.DFM}


{=== Obejekt.Definitionen =========}

procedure TFormHauptfenster.Beenden1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFormHauptfenster.Infoueber1Click(Sender: TObject);
begin
  {$IFDEF MitRegistrierung}
  FormInfo.Label1.Caption:='Registriert fr '
                            +FormRegistrieren.SaveRec.Vorname+' '
                            +FormRegistrieren.SaveRec.Nachname;
  FormInfo.Label1.Visible:=TRUE;
  {$ENDIF}
  FormInfo.ShowModal
end;

procedure TFormHauptfenster.Optionen1Click(Sender: TObject);
begin
  FormOptionen.ShowModal
  {Die Steuerelementwerte werden in der Behandlungsroutine
   fr den Abbrechen-Button entsprechend
   mit den alten Optionswerten zurckgesetzt
   oder der OptionenRec mit den Stuerelement inhalten gesetzt}
end;

PROCEDURE TFormHauptfenster.ArraySortieren(Max : CARDINAL);
{Selektion-Sort}
VAR I, J : Integer;
    T    : TTermin;
BEGIN
  for I := Low(Termine) to Max-1 do
    for J := Max downto I + 1 do
      if Termine[I].Datum > Termine[J].Datum then
      begin
        T := Termine[I];
        Termine[I] := Termine[J];
        Termine[J] := T;
      end;
END;

{=== PUBLIC-Implementierung ==============================}

PROCEDURE TFormHauptfenster.Init;
  {Darf und mu erst nach FormOptionen.Create im Hauptprogramm aufgerufen werden!!!}
  {Denn hier wird auf die Optionen zugegriffen, die erst initialisiert sein mssen}
  {Hier wird die Datendatei geladen und betrachtet, ob berhaupt etwas zu tun ist.}
  TYPE TDatum = RECORD
         Tag, Monat, Jahr : WORD;
       END;
  CONST WildCard : ShortSTRING = '*';
  VAR Datei          : TEXTFILE;
      Zeile          : ShortString;
      Zeilen_Datum   : TDatum;
      Akt_Datum      : TDatum;
      Letzter_Start1 : TDatum;
      Termine_in_Termindatei_gefunden : BOOLEAN;
      Anzuzeigende_Termine_gefunden   : BOOLEAN;
      i : CARDINAL;  {Zhler fr das Termine-Array}
      k : CARDINAL;  {Zhler fr die Wrter in der Bemerkung}
      j : CARDINAL;  {Zhler fr die Termine-Array bei der Ausgabe}
      m : CARDINAL;  {Zhler fr die Anzeige im StringGrid1}
  BEGIN
    {$IFDEF MitRegistrierung}
    FormRegistrieren.Caption:='Programm REMEMBER registrieren';
    IF NOT FormRegistrieren.RegistrierungOK THEN BEGIN
      Beep;
      FormRegistrieren.ShowModal;
      IF NOT FormRegistrieren.RegistrierungOK THEN Application.Terminate;
    END;
    {$ENDIF}
    Termine_in_Termindatei_gefunden:=FALSE;
    Anzuzeigende_Termine_gefunden:=FALSE;
    Timer1.Enabled:=FALSE;
    Label1.Caption:='Noch '
      + IntToStr(FormOptionen.OptionenRec.CountDownLaenge)
      + ' Sek. bis Programmende';
    WITH Akt_Datum DO BEGIN
      DecodeDate(Date,Jahr,Monat,Tag);
      Label3.Caption:=WTag(Date)+' '+IntToStr(Tag)+'.'+IntToStr(Monat)+'.'+IntToStr(Jahr);
    END;
    {Zu Testzwecken:}
    {FormOptionen.OptionenRec.Letzter_Start:=35631;}
    IF FormOptionen.OptionenRec.Letzter_Start < Date THEN
      WITH Letzter_Start1 DO BEGIN
        DecodeDate(FormOptionen.OptionenRec.Letzter_Start,Jahr,Monat,Tag);
        Label4.Caption:='letzter Start: '+WTag(FormOptionen.OptionenRec.Letzter_Start)
                         +' '+IntToStr(Tag)+'.'+IntToStr(Monat)+'.'+IntToStr(Jahr);
      END
    ELSE Label4.Visible:=FALSE;

    {Nach Terminen suchen und in Array eintragen:}
    IF SysUtils.FileExists(FormOptionen.OptionenRec.TerminDateiName) THEN BEGIN
      {Wenn die Termindatei exestiert:}
      i:=1; {mit Array-Platz 1 in Termine beginnen}
      System.AssignFile(Datei,FormOptionen.OptionenRec.TerminDateiName);
      TRY
        System.Reset(Datei);
        WHILE NOT Eof(Datei) DO BEGIN
          ReadLn(Datei,Zeile);
          IF NOT (ANSIUpperCase(WortN(Zeile,1))='REM') AND (Worte(Zeile) >= 3) THEN BEGIN
            {Wenn es keine Kommentarzeile ist oder zuwenig Wrter vorkommen}
            {Wenn Wrter keine Zahlen sind, dann Wert von aktuellem Datum verwenden:}
            Termine_in_Termindatei_gefunden:=TRUE;
            IF IstInteger(WortN(Zeile,1)) THEN BEGIN
              Zeilen_Datum.Tag:=StrToInt(WortN(Zeile,1));
              Termine[i].Tag  :=WortN(Zeile,1);
            END ELSE BEGIN
              Zeilen_Datum.Tag:=Akt_Datum.Tag;
              Termine[i].Tag  :=Wildcard;
            END;
            IF IstInteger(WortN(Zeile,2)) THEN BEGIN
              Zeilen_Datum.Monat:=StrToInt(WortN(Zeile,2));
              Termine[i].Monat:=WortN(Zeile,2);
            END ELSE BEGIN
              IF Zeilen_Datum.Tag>=Akt_Datum.Tag
                {Hiermit findet auch der Monatswechsel Bercksichtigung!!!}
                THEN Zeilen_Datum.Monat:=Akt_Datum.Monat
                ELSE Zeilen_Datum.Monat:=Akt_Datum.Monat+1;
              Termine[i].Monat:=WildCard;
            END;
            IF IstInteger(WortN(Zeile,3)) THEN BEGIN
              Zeilen_Datum.Jahr:=StrToInt(WortN(Zeile,3));
              Termine[i].Jahr :=WortN(Zeile,3);
            END ELSE BEGIN
              IF Zeilen_Datum.Monat>=Akt_Datum.Monat
                {Hiermit findet auch der Jahreswechsel Bercksichtigung!!!}
                THEN Zeilen_Datum.Jahr:=Akt_Datum.Jahr
                ELSE Zeilen_Datum.Jahr:=Akt_Datum.Jahr+1;
              Termine[i].Jahr :=WildCard;
            END;
            WITH Zeilen_Datum DO
              IF (Tag <= 31) AND (Monat <= 12) AND (Jahr<=5000) THEN BEGIN
                Termine[i].Datum:=EncodeDate(Jahr,Monat,Tag);
                Termine[i].Bemerkung:='';
                FOR k:=4 TO Worte(Zeile) DO BEGIN
                  {Die Restlichen Wrter als Bemerkung verwenden}
                  Termine[i].Bemerkung:=Termine[i].Bemerkung+' '+WortN(Zeile,k);
                END;
                i:=i+1;
              END;
          END;
        END;
      FINALLY
        System.CloseFile(Datei);
      END;

      {!!!!!!!!! Array sortieren !!!!!!!!!!!!!}
      ArraySortieren(i-1); {i-1 ist die Anzahl der Termine}

    END ELSE BEGIN
      {Wenn die Termindatei NICHT exestiert:}
      Beep;
      Dialogs.MessageDlg(
        'Die unter Optionen...|Termindatei eingetragene Datei kann nicht gefunden werden!',
        mtError,[mbOK],0);
    END;

    IF Termine_in_Termindatei_gefunden THEN BEGIN
      {Es wurden Termine in der Termindatei gefunden}
      StringGrid1.Cells[0,0]:='Tage';
      StringGrid1.Cells[1,0]:='WTag';
      StringGrid1.Cells[2,0]:='Tag';
      StringGrid1.Cells[3,0]:='Monat';
      StringGrid1.Cells[4,0]:='Jahr';
      StringGrid1.Cells[5,0]:='Bemerkung';
      m:=1;  {Zeilen-Nr im String-Grid}
      FOR j:=1 TO i-1 DO BEGIN {in i-1 ist die Anzahl der Termine}
        IF ((Termine[j].Datum > FormOptionen.OptionenRec.Letzter_Start)
             OR (Termine[j].Datum = Date))
        AND (Termine[j].Datum <= EnCodeDate(Akt_Datum.Jahr,Akt_Datum.Monat,Akt_Datum.Tag)
              + FormOptionen.OptionenRec.Tage_im_voraus)
        THEN BEGIN
          {Wenn Termin zwischen dem letzten Start und der Vorausanzeigezeit
           liegt im StringGrid anzeigen}
          Anzuzeigende_Termine_gefunden:=TRUE;
          {Trunc() : abschneiden der Nachkommastellen-> INTEGER:}
          StringGrid1.Cells[0,m]:=IntToStr(Trunc(Termine[j].Datum-Date));
          StringGrid1.Cells[1,m]:=WTag(Termine[j].Datum);
          StringGrid1.Cells[2,m]:=Termine[j].Tag;
          StringGrid1.Cells[3,m]:=Termine[j].Monat;
          StringGrid1.Cells[4,m]:=Termine[j].Jahr;
          StringGrid1.Cells[5,m]:=Termine[j].Bemerkung;
          IF (Termine[j].Datum > FormOptionen.OptionenRec.Letzter_Start)
          AND (Termine[j].Datum < EnCodeDate(Akt_Datum.Jahr,Akt_Datum.Monat,Akt_Datum.Tag))
            THEN StringGrid1.Cells[5,m]:= '!VORBEI!: ' + StringGrid1.Cells[5,m];
            {seit dem letzten Start vergangene Termine}
          m:=m+1;
          StringGrid1.RowCount:=m;
        END;
      END;
    END;

    IF Anzuzeigende_Termine_gefunden THEN BEGIN
      IF FormOptionen.OptionenRec.Signale_abspielen
      AND FileExists(FormOptionen.OptionenRec.Signal_TerminGefunden) THEN BEGIN
        FormOptionen.MediaPlayer1.FileName:=FormOptionen.OptionenRec.Signal_TerminGefunden;
        TRY
          FormOptionen.MediaPlayer1.Open;
          FormOptionen.MediaPlayer1.Play;
        EXCEPT
          ON EMCIDeviceError DO FormOptionen.OptionenRec.Signale_abspielen:=FALSE;
        END;
      END;
      Label2.Caption:='Es wurden folgende Termine innerhalb der nchsten '
                       +IntToStr(FormOptionen.OptionenRec.Tage_im_voraus)
                       +' Tage gefunden:';
      IF FormOptionen.OptionenRec.CountDownStarten THEN BEGIN
        CountDown_starten; {Methode aufrufen}
      END ELSE BEGIN
        {Programm luft bis der User beendet.}
        {CountdownElemente deaktivieren:}
        ButtonStopCountdown.Visible:=FALSE;
        Gauge1.Visible:=FALSE;
        Label1.Visible:=FALSE;
        BitBtnSchliessen.Cancel:=TRUE;  {Bei Taste ESC Progr. beenden}
      END;
    END ELSE BEGIN
      IF FormOptionen.OptionenRec.Signale_abspielen
      AND FileExists(FormOptionen.OptionenRec.Signal_TerminGefunden) THEN BEGIN
        FormOptionen.MediaPlayer1.FileName:=FormOptionen.OptionenRec.Signal_keinTermin;
        TRY
          FormOptionen.MediaPlayer1.Open;
          FormOptionen.MediaPlayer1.Play;
        EXCEPT
          {Tritt der folgende Fehler auf ist wahrsch. keine Soundkarte installiert}
          ON EMCIDeviceError DO FormOptionen.OptionenRec.Signale_abspielen:=FALSE;
        END;
      END;

      IF FormOptionen.OptionenRec.Anwendung_immer_starten THEN BEGIN
        Label2.Caption:='Es wurden KEINE Termine innerhalb der nchsten '
                         +IntToStr(FormOptionen.OptionenRec.Tage_im_voraus)
                         +' Tage gefunden!';
        FormHauptFenster.Height:=150;
        IF FormOptionen.OptionenRec.CountDownStarten THEN BEGIN
          CountDown_starten; {Methode aufrufen}
        END ELSE BEGIN
          {Programm luft bis der User beendet.}
          {CountdownElemente deaktivieren:}
          ButtonStopCountdown.Visible:=FALSE;
          Gauge1.Visible:=FALSE;
          Label1.Visible:=FALSE;
          BitBtnSchliessen.Cancel:=TRUE;  {Bei Taste ESC Progr. beenden}
        END;
      END ELSE BEGIN
        {Programm beendet sich von selber}
        Application.Terminate;
      END;
    END;
  END;

PROCEDURE TFormHauptfenster.CountDown_starten;
  BEGIN
    {Countdown}
    CountDownZaehler:=FormOptionen.OptionenRec.CountdownLaenge;
    Gauge1.MaxValue:=FormOptionen.OptionenRec.CountdownLaenge;
    {Menpunkte deaktivieren:}
    Termindateibearbeiten1.Enabled:=FALSE;
    Optionen1.Enabled:=FALSE;
    Hilfe2.Enabled:=FALSE;
    Timer1.Enabled:=TRUE; {CountDown starten}
  END;

PROCEDURE TFormHauptfenster.Termine_drucken;
VAR PrintText : TextFile; {Ausgabe auf Drucker, wie in alten Zeiten}
    Z         : BYTE;     {Zeile im StringGrid}
BEGIN
  AssignPrn(PrintText);
  Rewrite(PrintText);
  TRY
    Printer.Canvas.Font.Name:= 'Courier New';
    Printer.Canvas.Font.Size:=17;
    writeln(PrintText,'Remember-Terminbersicht   '+Label3.Caption);
    Printer.Canvas.Font.Size:=12;
    writeln(PrintText);
    writeln(PrintText,Label2.Caption);
    Printer.Canvas.Font.Size:=12;
    writeln(PrintText);
    writeln(PrintText,'Tage WTag TT MM JJJJ  Bemerkung');
    writeln(PrintText,'-------------------------------------------------------------------');
    FOR Z:=1 TO StringGrid1.RowCount DO BEGIN
      IF StrToIntDef(StringGrid1.Cells[0,Z],1)<=0
        THEN Printer.Canvas.Font.Color:=clRed
        ELSE Printer.Canvas.Font.Color:=clBlack;
      {Programm strzte, wenn aus Delphi aufgerufen manchmal ab
       wegen der Abfrage mit StrToInt() (warum auch immer)}
      write  (PrintText,StringGrid1.Cells[0,Z]:3,'   ');  {Tage}
      write  (PrintText,StringGrid1.Cells[1,Z]:2,'  ');   {WTag}
      write  (PrintText,StringGrid1.Cells[2,Z]:2,' ');    {TT}
      write  (PrintText,StringGrid1.Cells[3,Z]:2,' ');    {MM}
      write  (PrintText,StringGrid1.Cells[4,Z]:4,' ');    {JJJJ}
      writeln(PrintText,StringGrid1.Cells[5,Z]);          {Bemerkung}
    END;

  FINALLY
    CloseFile(PrintText);
  END;
END;

procedure TFormHauptfenster.ButtonStopCountdownClick(Sender: TObject);
begin
  Timer1.Enabled:=FALSE; {CountDown abbrechen}
  {Menpunkte reaktivieren:}
  Termindateibearbeiten1.Enabled:=TRUE;
  Optionen1.Enabled:=TRUE;
  Hilfe2.Enabled:=TRUE;
  {CountdownElemente deaktivieren:}
  ButtonStopCountdown.Visible:=FALSE;
  Gauge1.Visible:=FALSE;
  Label1.Visible:=FALSE;
  BitBtnSchliessen.Cancel:=TRUE; {Nun kann die Anwendung mit ESC beendet werden}
  {Beep;}
end;

procedure TFormHauptfenster.Timer1Timer(Sender: TObject);
begin
  IF CountDownZaehler > 1 THEN BEGIN
    CountDownZaehler:=CountDownZaehler-1;
    Label1.Caption:='Noch ' + IntToStr(CountDownZaehler) + ' Sek. bis Programmende';
    Gauge1.Progress:=FormOptionen.OptionenRec.CountdownLaenge-CountDownZaehler;
  END ELSE BEGIN
    FormOptionen.Optionen_Speichern;
    Application.Terminate;   {Programm beenden}
  END;
end;

procedure TFormHauptfenster.Termindateibearbeiten1Click(Sender: TObject);
begin
  {Die Termindatei im Windows-Editor ffnen}
  FormStyle:=fsNormal; {von nun an ist das Fenster nicht mehr StayOnTop}
  WITH FormOptionen.OptionenRec DO
  ZusatzProcs.ExecuteFile('notepad.exe',TerminDateiName,'',1);
end;

procedure TFormHauptfenster.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
{Wird immer bei Programmbeendigung aufgerufen}
begin
  FormOptionen.Optionen_Speichern;
  {insbesondere wegen OptionenRec.Letzter_Start wird hier gespeichert!}
end;

procedure TFormHauptfenster.Kurzhilfe1Click(Sender: TObject);
begin
  FormKurzhilfe.ShowModal;
end;


procedure TFormHauptfenster.Termindateineuladen1Click(Sender: TObject);
begin
  Init;
  ButtonStopCountdownClick(Sender);
end;

procedure TFormHauptfenster.Termindateidrucken1Click(Sender: TObject);
{Kontextsensitives- & Pulldown-Men}
begin
  Termine_drucken;
end;

END.
