UNIT Optionen;

{Noch zu erledigen:
1. Bei Programmende immer die Optionendatei speichern}

INTERFACE

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, Mask, ExtCtrls, MPlayer;

TYPE TOptionenRec = RECORD
       {in diesem Typ werden die Anwendungsoptionen gespeichert und
       fr den Programmablauf bereitgestellt}
       Anwendung_immer_starten : BOOLEAN;
       CountDownStarten        : BOOLEAN;
       CountdownLaenge         : CARDINAL;
       Tage_im_voraus          : CARDINAL;
       Letzter_Start           : TDateTime;   {Datum des letzten Programmaufrufs}
       TerminDateiName         : ShortString; {Hat im Gegens. zu STRING feste Lnge!}
       Signal_TerminGefunden   : ShortString;
       Signal_keinTermin       : ShortString;
       Signale_abspielen       : BOOLEAN;
     END;

type
  TFormOptionen = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    BitBtnOK: TBitBtn;
    BitBtnAbbrechen: TBitBtn;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    MaskEditCountDownLaenge: TMaskEdit;
    StaticText1: TStaticText;
    UpDownCountDownLaenge: TUpDown;
    OpenDialog1: TOpenDialog;
    TabSheet3: TTabSheet;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    Edit2: TEdit;
    Edit3: TEdit;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    StaticText3: TStaticText;
    MaskEditTageImVoraus: TMaskEdit;
    UpDownTageImVoraus: TUpDown;
    StaticText2: TStaticText;
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    MediaPlayer1: TMediaPlayer;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure BitBtnOKClick(Sender: TObject);
    procedure BitBtnAbbrechenClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private-Deklarationen }
    OptionenDateiName : STRING;
    {Hier wird im Construktor Create zentral der Pfad auf die Optionendatei gesetzt}

  public
    { Public-Deklarationen }
    OptionenRec : TOptionenRec;
    {Hierin werden die Optionen fr den Programmablauf zur Verfgung gestellt.}

    CONSTRUCTOR Create(AOwner : TComponent); override;
    PROCEDURE Optionen_in_Steuerelemente_schreiben;
    PROCEDURE Steuerelemente_in_Optionen_Schreiben;
    PROCEDURE Optionen_speichern;   {OptionenRec speichern}
    PROCEDURE Optionen_laden;
  end;

var
  FormOptionen: TFormOptionen;


IMPLEMENTATION

USES ZusatzProcs;

{$R *.DFM}

{=== PUBLIC-Implementierung ==============================}

CONSTRUCTOR TFormOptionen.Create(AOwner : TComponent);
  {Besser ist es wohl eine Ereignisbehandlungsmethode dem Ereignis
   OnCreate zuzuweisen; zum Abschlu der Anwendung: OnDestroy}
  BEGIN
    {Zuerst die geerbete Initialisierung aufrufen!}
    Inherited Create(AOwner);
    {Nun folgen die eigenen Initialisierungen:}
    OptionenDateiName:=ZuhausePfad+'\REMEMBER.OPT';
    OptionenRec.Letzter_Start:=Date;  {das aktuelle Datum zuweisen}
    IF SysUtils.FileExists(OptionenDateiName) THEN BEGIN
      Optionen_laden;
      Optionen_in_Steuerelemente_schreiben;
    END ELSE BEGIN
      {Standardeinstellungen einrichten:}
      WITH OptionenRec DO BEGIN
        Anwendung_immer_starten:=TRUE;  {Standard: FALSE}
        CountDownStarten       :=TRUE; {Standard: TRUE}
        CountdownLaenge        :=20;
        Tage_im_voraus         :=14;
        Letzter_Start          :=Date;  {das aktuelle Datum zuweisen}
        TerminDateiName        :=ZuhausePfad+'\REMEMBER.TXT';
        Signal_TerminGefunden  :='';
        Signal_keinTermin      :='';
        Signale_abspielen      :=FALSE;
      END;
      Optionen_in_Steuerelemente_schreiben
    END;
  END;

PROCEDURE TFormOptionen.Optionen_in_Steuerelemente_schreiben;
  {Steuerlementwerte wieder mit den OptionswerteRecord zurcksetzen}
  BEGIN
    WITH OptionenRec DO BEGIN
      IF Anwendung_immer_starten
        THEN RadioGroup1.ItemIndex:=1
        ELSE RadioGroup1.ItemIndex:=0;
      IF CountDownStarten
        THEN RadioGroup2.ItemIndex:=0
        ELSE RadioGroup2.ItemIndex:=1;
      {MaskEditCountdownLaenge.Text:=IntToStr(CountdownLaenge);
      MaskEditTageImVoraus.Text   :=IntToStr(Tage_im_voraus);}
      UpDownTageImVoraus.Position   :=Tage_im_voraus;
      UpDownCountDownLaenge.Position:=CountdownLaenge;
      Edit1.Text:=TerminDateiName;
      Edit2.Text:=Signal_TerminGefunden;
      Edit3.Text:=Signal_keinTermin;
      IF Signale_abspielen
        THEN Checkbox1.State:=cbChecked
        ELSE Checkbox1.State:=cbUnChecked;
    END;
END;

PROCEDURE TFormOptionen.Steuerelemente_in_Optionen_Schreiben;
  {Steuerlementwerte in OptionswerteRecord bertragen}
  BEGIN
    WITH OptionenRec DO BEGIN
      Anwendung_immer_starten:=RadioGroup1.ItemIndex=1;
      CountDownStarten       :=RadioGroup2.ItemIndex=0;
{      CountdownLaenge        :=StrToInt(MaskEditCountdownLaenge.Text);
      Tage_im_voraus         :=StrToInt(MaskEditTageImVoraus.Text);}
      CountdownLaenge        :=UpDownCountdownLaenge.Position;
      Tage_im_voraus         :=UpDownTageImVoraus.Position;
      TerminDateiName        :=Edit1.Text;
      Signal_TerminGefunden  :=Edit2.Text;
      Signal_keinTermin      :=Edit3.Text;
      Signale_abspielen      :=Checkbox1.State=cbChecked;
    END;
  END;


procedure TFormOptionen.Button1Click(Sender: TObject);
begin
  IF OpenDialog1.Execute THEN Edit1.Text:=Opendialog1.FileName
end;

procedure TFormOptionen.Button2Click(Sender: TObject);
begin
  IF OpenDialog1.Execute THEN Edit2.Text:=Opendialog1.FileName
end;

procedure TFormOptionen.Button3Click(Sender: TObject);
begin
  IF OpenDialog1.Execute THEN Edit3.Text:=Opendialog1.FileName
end;


{=== PRIVATE-Implementierung ================================}



PROCEDURE TFormOptionen.Optionen_speichern;   {OptionenRec speichern}
  {Die Optionen-Datei wird immer im Verzeichnis gesucht,
   in dem sich auch die EXE-Datei der Anwendung befindet.}
  VAR Datei : FILE OF TOptionenRec;
  BEGIN
     {Aktuelles Datum mitsichern:}
     OptionenRec.Letzter_Start:=Date;
    {Funktionen aus Unit SYSTEM aufrufen}
    System.AssignFile(Datei,OptionenDateiName);
    {OptionenDateiname wird im Construktor Create zentral gesetzt}
    TRY
      System.ReWrite(Datei);
      write(Datei,OptionenRec);
    FINALLY
      System.CloseFile(Datei);
    END;
  END;

PROCEDURE TFormOptionen.Optionen_laden;
  VAR Datei : FILE OF TOptionenRec;
  BEGIN
    {Funktionen aus Unit SYSTEM aufrufen}
    IF FileExists(OptionenDateiName) THEN BEGIN
      System.AssignFile(Datei,OptionenDateiName);
      System.Reset(Datei);
      TRY
        read(Datei,OptionenRec);
      FINALLY
        System.CloseFile(Datei);
      END;
      {ELSE braucht nicht abgefragt zu werden:
      bei Programmbeendigung wird eine Optionendatei erzeugt}
    END;
  END;


procedure TFormOptionen.BitBtnOKClick(Sender: TObject);
begin
  {Steuerlementwerte in OptionswerteRecord bertragen}
  {und danach in Datei speichern}
  Steuerelemente_in_Optionen_Schreiben;
  Optionen_Speichern;
end;

procedure TFormOptionen.BitBtnAbbrechenClick(Sender: TObject);
begin
  {Steuerlementwerte wieder mit den OptionswerteRecord zurcksetzen}
  Optionen_in_Steuerelemente_schreiben;
end;

procedure TFormOptionen.Button4Click(Sender: TObject);
begin
  IF FileExists(Edit2.Text) THEN BEGIN
    MediaPlayer1.FileName:=Edit2.Text;
    TRY
      MediaPlayer1.Open;  {Close wird bei beenden der Anwendung autom. aufgerufen}
      MediaPlayer1.Play;
    EXCEPT
      ON EMCIDeviceError DO OptionenRec.Signale_abspielen:=FALSE;
    END;
  END ELSE BEGIN
    MessageDlg('Die Datei '+Edit2.Text+' exestiert nicht!',mtError,[mbOK],0);
    Edit2.SetFocus;
  END;
end;

procedure TFormOptionen.Button5Click(Sender: TObject);
begin
  IF FileExists(Edit3.Text) THEN BEGIN
    MediaPlayer1.FileName:=Edit3.Text;
    TRY
      MediaPlayer1.Open;  {Close wird bei beenden der Anwendung autom. aufgerufen}
      MediaPlayer1.Play;
    EXCEPT
      ON EMCIDeviceError DO OptionenRec.Signale_abspielen:=FALSE;
    END;
  END ELSE BEGIN
    MessageDlg('Die Datei '+Edit3.Text+' exestiert nicht!',mtError,[mbOK],0);
    Edit3.SetFocus;
  END;

end;

end.
